IT: OTS (China) -0000 #278

Update FedEx RESTful APls
06/12/2023 02:14 PM - Xihua Fan

Status: oo0 Start date: 02/01/2024
Priority: aa Due date: 08/30/2024
Assignee: Junyi Zhang % Done: 100%
Category: Estimated time: 8.00 hours
Target version: v3.0 Spent time: 0.00 hour
Description

Task Details

1. Email: [0l Web Services —I1ll FedEx RESTful APIs 000000]
Link:
https://developer.fedex.com/api/zh-cn/home.html?cmp=EMT-1007031-3-3-200-1000000-APAC-CN-ZH-EMDITFY22WSAWAR&
ET_CID=1225625& ET_RID=14212675&LINK=BodyCopy-CTA3
Fedex API 00 [apacwebservices@fedex.com
Fedex 00 [fdxhelpdesk@fedex.com
Fedex 00 (0010)lecndcc@tedex.comlI0000000gavin.zhang@tedex.com

Important(]

1. The web service will no longer be able to be used on August 31, 2024 https://developer.fedex.com.cn/api/zh-cn/home.html

G = developer.fedex.com.cn/api/zh-cn/home html %

Fed
Input
Output
¢ Report and Solution

Others

History

#1 - 08/18/2023 10:33 AM - Xihua Fan
- Start date changed from 07/01/2023 to 10/01/2023

#2 - 12/14/2023 04:57 PM - Xihua Fan
- Due date changed from 12/31/2023 to 03/31/2024
- Start date changed from 10/01/2023 to 02/01/2024

#3 - 03/29/2024 04:19 PM - Junyi Zhang
- % Done changed from 0 to 10

#4 - 04/01/2024 09:53 AM - Xihua Fan
- Due date changed from 03/31/2024 to 04/30/2024

#5 - 04/03/2024 07:41 PM - Junyi Zhang
- % Done changed from 10 to 30

#6 - 04/07/2024 10:19 AM - Xihua Fan
- Due date changed from 04/30/2024 to 05/15/2024
#7 - 04/07/2024 10:24 AM - Junyi Zhang
- % Done changed from 30 to 40

#8 - 04/07/2024 11:14 AM - Xihua Fan

- Description updated

#9 - 04/07/2024 11:14 AM - Xihua Fan

- Description updated

#10 - 04/10/2024 11:09 AM - Junyi Zhang
- % Done changed from 40 to 50

#11 - 04/18/2024 10:14 AM - Xihua Fan
- Tracker changed from 00 Bug to (0000

#12 - 05/16/2024 11:33 AM - Xihua Fan
- Due date changed from 05/15/2024 to 05/31/2024

#13 - 05/28/2024 12:35 PM - Xihua Fan
- Due date changed from 05/31/2024 to 06/30/2024
- % Done changed from 50 to 90

#14 - 05/30/2024 11:18 AM - Junyi Zhang

- Description updated

#15 - 05/30/2024 11:21 AM - Junyi Zhang

- Description updated

#16 - 05/30/2024 11:23 AM - Xihua Fan
- File clipboard-202405301122-uanwd.png added

- Description updated

#17 - 06/25/2024 03:55 PM - Junyi Zhang
- File OTS_FedEx_Restful_api_20240625.7z added

#18 - 06/27/2024 06:46 PM - Junyi Zhang
Outputl 2024/06/27), Outputl 2024/06/24), Outputl 2024/06/03), Outputl 2024/04/08), Outputl 2024/04/03), Outputl 2024/03/29)

Fedex Developer portal: (https://developer.fedex.com.cn/api/en-us/home.html ) (100%)

1. Account:
- Id: vanfan0826
- Password: Fxh19780826
2. Organization info:
- company name: redblue
- company URL: order.easydingzhi.com
- organization name: redblue-OTS
3. Api project: redblue-OTS-tracking(100%)
1. Test environment:

Test URL: https://apis-sandbox.fedex.com
Api key: 17e8236d9b45d84allb3244346eddeblc3
Serect key: 68£98c0d55b2410490el9bf576afc71lc

2. Production environment:
URL: https://apis.fedex.com
API key: 174ba73772d6d14e77813e35£504866146

Serect key: 201021lada319420bad9756a492£f35a5f (Noted: To Keep your Secret Key secure, Fedex only displa
y it once. If you lose your Secret Key, you can generate a new one. )
3. About API request limit: (https://developer.fedex.com.cn/api/en-cn/guides/ratelimits.html))

API request: 500,000 per day in one organization, 1,400 per 10s

Auth token threshold: 3/s in 5s or 1/s in 2 min

Changes:(100%)

1. Add settings in protected/tracking.ini:

; —— True: Restful API, False: Webservice —- ;
fedex_restful_api = false

; —— Test environment —-- ;

fedex_api_url = https://apis-sandbox.fedex.com
fedex_api_key = 17e8236d9b45d84allb3244346eddeblc3
fedex_secret_key = 68f98c0d55b2410490el19bf576afc71lc
fedex_grant_type = client_credentials

; —— Production environment —- ;

; fedex_api_url https://apis.fedex.com
;fedex_api_key = 174ba73772d6d14e77813e35£504866146
; fedex_secret_key = 201021ada319420bad9756a492£35a5f
; fedex_grant_type = client_credentials

2. Change scope:
- protected/tracking.ini
- protected/components/TrackingFedEx.php
- protected/actions/track/QueryAction.php
3. Add RestFul api support to Fedex tracking function.
1. protected/components/TrackingFedEx.php:
- Support WebService and Restfule API.
- Restfule api: 1. Get access_token 2. Get tracking data by access_token.

2. Unify the front Ul display (WebService and Restful API) since the front js file was compressed.
- | change the data structure of Restful to as the same as the web service to make front display easier.

- Web service:

"TrackingNumber":"772221506449",
"Events": {
"Timestamp":"2023-05-26T12:30:00+00:00",
"EventType":"DL",
"EventDescription":"Delivered",
"Address": {
"City":"DALLAS",
"StateOrProvinceCode":"TX",
"PostalCode":"75202",
"CountryCode":"US",
"Residential":false
by
"ArrivalLocation":"DELIVERY_LOCATION"

- Restful:

Old:
{
"output": {
"completeTrackResults": [
{
"trackingNumber":"772221506449",
"trackResults": [
{
"scanEvents": [
{
"date":"2023-05-26T12:30:00+00:00",
"eventType":"DL",
"eventDescription":"Delivered",
"scanLocation": {
"city":"DALLAS",
"stateOrProvinceCode":

"postalCode":"75202",
"countryCode":"US",
"residential":false

New:

"TrackingNumber":"772221506449",
"Events": [

{

"Timestamp":"2023-05-26T12:30:00+00:00",

"EventDescription":"Delivered",
"Address": {
T@i W™ 8 TDALLAST .
"CountryCode" :"US"

#19 - 06/27/2024 07:09 PM - Junyi Zhang
- File deleted (OTS_FedEx_Restful_api 20240625.7z)

#20 - 06/27/2024 07:09 PM - Junyi Zhang
- File OTS_FedEx_Restful_api 20240627.7z added

#21 - 06/28/2024 10:47 AM - Xihua Fan
- Due date changed from 06/30/2024 to 07/31/2024

#22 - 07/30/2024 11:31 AM - Xihua Fan
- Due date changed from 07/31/2024 to 08/16/2024

#23 - 08/16/2024 07:02 PM - Xihua Fan
- Due date changed from 08/16/2024 to 08/30/2024

To Niko

n"TX",

1. 008/2300commitlGitl 00000000000, 000000Gitl0Apachel00OODOOD

Notel000000000000000000000000000D

#24 - 09/02/2024 06:54 PM - Junyi Zhang
Outputl 2024/09/02)

1. BugFix: Tracking function only display the latest tracking information, which should display all the tracking history information.
1. Solution: Modify FedEx Restful api, and get all the tracking history information instead the latest one.

2. Change scope:
- protected/components/TrackingFedEx.php

#25 - 09/02/2024 06:55 PM - Junyi Zhang
- Status changed from 000 to0010
- % Done changed from 90 to 100

#26 - 10/08/2024 10:57 AM - Xihua Fan

- Target version set to v3.0
Files

clipboard-202405301122-uanwd.png 50.4 KB 05/30/2024 Xihua Fan
OTS_FedEx_Restful_api_20240627.7z 10.1 KB 06/27/2024 Junyi Zhang
